# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.directed_graph_algorithm import DirectedGraphAlgorithm


class BoostDividedEdgeBundling(DirectedGraphAlgorithm):
    r"""
    BoostDividedEdgeBundling - layout graph edges in directed edge
    bundles
    
    Superclass: DirectedGraphAlgorithm
    
    Uses the technique by Selassie, Heller, and Heer to route graph edges
    into directed bundles, with "lanes" for bundled edges moving in each
    direction. This technique works best for networks whose vertices have
    been positioned already (geospatial graphs, for example). Note that
    this scales to a few thousand edges in a reasonable period of time
    (~1 minute). The time complexity comes mainly from the doubling of
    edge control points each cycle and the complex set of forces between
    many pairs of edge points.
    
    The algorithm depends on the Boost graph library for its
    implementation of all-pairs shortest paths, needed here for
    determining connectivity compatibility.
    
    @par Thanks: This algorithm was developed in the paper:
      David Selassie, Brandon Heller, Jeffrey Heer. Divided Edge Bundling
    for Directional
      Network Data. Proceedings of IEEE info_vis 2011.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkBoostDividedEdgeBundling, obj, update, **traits)
    
    _updateable_traits_ = \
    (('abort_execute', 'GetAbortExecute'), ('release_data_flag',
    'GetReleaseDataFlag'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'), ('progress',
    'GetProgress'), ('progress_text', 'GetProgressText'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'debug', 'global_warning_display',
    'release_data_flag', 'progress_text'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(BoostDividedEdgeBundling, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit BoostDividedEdgeBundling properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], []),
            title='Edit BoostDividedEdgeBundling properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit BoostDividedEdgeBundling properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

