# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.closest_point_strategy import ClosestPointStrategy


class ClosestNPointsStrategy(ClosestPointStrategy):
    r"""
    ClosestNPointsStrategy - implement a specific
    PointSet::FindCell() strategy based
             on the N closest points
    
    Superclass: ClosestPointStrategy
    
    ClosestNPointsStrategy is implements a find_cell() strategy based
    on locating the closest N points in a dataset, and then searching
    attached cells. This class extends its superclass
    ClosestPointStrategy by looking at the additional N points.
    
    @sa
    FindCellStrategy PointSet
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkClosestNPointsStrategy, obj, update, **traits)
    
    closest_n_points = traits.Trait(9, traits.Range(1, 100, enter_set=True, auto_set=False), desc=\
        r"""
        Set / get the value for the N closest points.
        """
    )

    def _closest_n_points_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetClosestNPoints,
                        self.closest_n_points)

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('closest_n_points', 'GetClosestNPoints'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'closest_n_points'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(ClosestNPointsStrategy, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit ClosestNPointsStrategy properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['closest_n_points']),
            title='Edit ClosestNPointsStrategy properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit ClosestNPointsStrategy properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

