# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.object import Object


class CPExodusIIElementBlockImpl(Object):
    r"""
    CPExodusIIElementBlockImpl - no description provided.
    
    Superclass: Object
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkCPExodusIIElementBlockImpl, obj, update, **traits)
    
    def get_cell_points(self, *args):
        """
        get_cell_points(self, cellId:int, ptIds:IdList) -> None
        C++: void get_cell_points(IdType cellId, IdList *ptIds)"""
        my_args = deref_array(args, [('int', 'vtkIdList')])
        ret = self._wrap_call(self._vtk_obj.GetCellPoints, *my_args)
        return ret

    def get_cell_type(self, *args):
        """
        get_cell_type(self, cellId:int) -> int
        C++: int get_cell_type(IdType cellId)"""
        ret = self._wrap_call(self._vtk_obj.GetCellType, *args)
        return ret

    def get_ids_of_cells_of_type(self, *args):
        """
        get_ids_of_cells_of_type(self, type:int, array:IdTypeArray) -> None
        C++: void get_ids_of_cells_of_type(int type, IdTypeArray *array)"""
        my_args = deref_array(args, [('int', 'vtkIdTypeArray')])
        ret = self._wrap_call(self._vtk_obj.GetIdsOfCellsOfType, *my_args)
        return ret

    def _get_max_cell_size(self):
        return self._vtk_obj.GetMaxCellSize()
    max_cell_size = traits.Property(_get_max_cell_size, desc=\
        r"""
        
        """
    )

    def _get_number_of_cells(self):
        return self._vtk_obj.GetNumberOfCells()
    number_of_cells = traits.Property(_get_number_of_cells, desc=\
        r"""
        
        """
    )

    def get_point_cells(self, *args):
        """
        get_point_cells(self, ptId:int, cellIds:IdList) -> None
        C++: void get_point_cells(IdType ptId, IdList *cellIds)"""
        my_args = deref_array(args, [('int', 'vtkIdList')])
        ret = self._wrap_call(self._vtk_obj.GetPointCells, *my_args)
        return ret

    def allocate(self, *args):
        """
        allocate(self, numCells:int, extSize:int=1000) -> None
        C++: void allocate(IdType numCells, int extSize=1000)"""
        ret = self._wrap_call(self._vtk_obj.Allocate, *args)
        return ret

    def insert_next_cell(self, *args):
        """
        insert_next_cell(self, type:int, ptIds:IdList) -> int
        C++: IdType insert_next_cell(int type, IdList *ptIds)
        insert_next_cell(self, type:int, npts:int, ptIds:(int, ...)) -> int
        C++: IdType insert_next_cell(int type, IdType npts,
            const IdType ptIds[])
        insert_next_cell(self, type:int, npts:int, ptIds:(int, ...),
            nfaces:int, faces:(int, ...)) -> int
        C++: IdType insert_next_cell(int type, IdType npts,
            const IdType ptIds[], IdType nfaces,
            const IdType faces[])"""
        my_args = deref_array(args, [('int', 'vtkIdList'), ('int', 'int', ('int', Ellipsis)), ('int', 'int', ('int', Ellipsis), 'int', ('int', Ellipsis))])
        ret = self._wrap_call(self._vtk_obj.InsertNextCell, *my_args)
        return ret

    def is_homogeneous(self):
        """
        is_homogeneous(self) -> int
        C++: int is_homogeneous()"""
        ret = self._vtk_obj.IsHomogeneous()
        return ret
        

    def replace_cell(self, *args):
        """
        replace_cell(self, cellId:int, npts:int, pts:(int, ...)) -> None
        C++: void replace_cell(IdType cellId, int npts,
            const IdType pts[])"""
        ret = self._wrap_call(self._vtk_obj.ReplaceCell, *args)
        return ret

    def set_exodus_connectivity_array(self, *args):
        """
        set_exodus_connectivity_array(self, elements:[int, ...], type:str,
            numElements:int, nodesPerElement:int) -> bool
        C++: bool set_exodus_connectivity_array(int *elements,
            const std::string &type, int numElements, int nodesPerElement)
        Set the Exodus element block data. 'elements' is the array
        returned from ex_get_elem_conn. 'type', 'numElements', and
        'nodesper_element' are obtained from ex_get_elem_block. Returns
        true or false depending on whether or not the element type can be
        translated into a VTK cell type. This object takes ownership of
        the elements array unless this function returns false.
        """
        ret = self._wrap_call(self._vtk_obj.SetExodusConnectivityArray, *args)
        return ret

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(CPExodusIIElementBlockImpl, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit CPExodusIIElementBlockImpl properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], []),
            title='Edit CPExodusIIElementBlockImpl properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit CPExodusIIElementBlockImpl properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

