# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.table_algorithm import TableAlgorithm


class ExtractSelectedRows(TableAlgorithm):
    r"""
    ExtractSelectedRows - return selected rows of a table
    
    Superclass: TableAlgorithm
    
    The first input is a Table to extract rows from. The second input
    is a Selection containing the selected indices. The third input is
    a AnnotationLayers containing selected indices. The field type of
    the input selection is ignored when converted to row indices.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkExtractSelectedRows, obj, update, **traits)
    
    add_original_row_ids_array = tvtk_base.false_bool_trait(desc=\
        r"""
        When set, a column named OriginalRowIds will be added to the
        output. False by default.
        """
    )

    def _add_original_row_ids_array_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetAddOriginalRowIdsArray,
                        self.add_original_row_ids_array_)

    def fill_input_port_information(self, *args):
        """
        fill_input_port_information(self, port:int, info:Information)
            -> int
        C++: int fill_input_port_information(int port, Information *info)
            override;
        Specify the first Graph input and the second Selection
        input.
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.FillInputPortInformation, *my_args)
        return ret

    def set_annotation_layers_connection(self, *args):
        """
        set_annotation_layers_connection(self, in_:AlgorithmOutput)
            -> None
        C++: void set_annotation_layers_connection(AlgorithmOutput *in)
        A convenience method for setting the third input (i.e. the
        annotation layers).
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.SetAnnotationLayersConnection, *my_args)
        return ret

    def set_selection_connection(self, *args):
        """
        set_selection_connection(self, in_:AlgorithmOutput) -> None
        C++: void set_selection_connection(AlgorithmOutput *in)
        A convenience method for setting the second input (i.e. the
        selection).
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.SetSelectionConnection, *my_args)
        return ret

    _updateable_traits_ = \
    (('add_original_row_ids_array', 'GetAddOriginalRowIdsArray'),
    ('abort_execute', 'GetAbortExecute'), ('release_data_flag',
    'GetReleaseDataFlag'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'), ('progress',
    'GetProgress'), ('progress_text', 'GetProgressText'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'add_original_row_ids_array', 'debug',
    'global_warning_display', 'release_data_flag', 'progress_text'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(ExtractSelectedRows, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit ExtractSelectedRows properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['add_original_row_ids_array'], [], []),
            title='Edit ExtractSelectedRows properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit ExtractSelectedRows properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

