# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.object import Object


class GDALRasterReprojection(Object):
    r"""
    GDALRasterReprojection - 
    
    Superclass: Object
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkGDALRasterReprojection, obj, update, **traits)
    
    def _get_max_error_max_value(self):
        return self._vtk_obj.GetMaxErrorMaxValue()
    max_error_max_value = traits.Property(_get_max_error_max_value, desc=\
        r"""
        
        """
    )

    def _get_max_error_min_value(self):
        return self._vtk_obj.GetMaxErrorMinValue()
    max_error_min_value = traits.Property(_get_max_error_min_value, desc=\
        r"""
        
        """
    )

    def _get_resampling_algorithm_max_value(self):
        return self._vtk_obj.GetResamplingAlgorithmMaxValue()
    resampling_algorithm_max_value = traits.Property(_get_resampling_algorithm_max_value, desc=\
        r"""
        
        """
    )

    def _get_resampling_algorithm_min_value(self):
        return self._vtk_obj.GetResamplingAlgorithmMinValue()
    resampling_algorithm_min_value = traits.Property(_get_resampling_algorithm_min_value, desc=\
        r"""
        
        """
    )

    def set_max_error(self, *args):
        """
        set_max_error(self, _arg:float) -> None
        C++: virtual void set_max_error(double _arg)
        The maximum error measured in input pixels that is allowed in
        approximating the reprojection transformation (0.0 for exact
        calculations).
        """
        ret = self._wrap_call(self._vtk_obj.SetMaxError, *args)
        return ret

    def set_resampling_algorithm(self, *args):
        """
        set_resampling_algorithm(self, _arg:int) -> None
        C++: virtual void set_resampling_algorithm(int _arg)
        Pixel resampling algorithm, between 0 and 6 0 = Nearest Neighbor
        (default) 1 = Bilinear 2 = Cubic 3 = cubic_spline 4 = Lanczos 5 =
        Average (GDAL 1.10) 6 = Mode    (GDAL 1.10)
        """
        ret = self._wrap_call(self._vtk_obj.SetResamplingAlgorithm, *args)
        return ret

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(GDALRasterReprojection, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit GDALRasterReprojection properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], []),
            title='Edit GDALRasterReprojection properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit GDALRasterReprojection properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

