# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.mapper import Mapper


class Glyph3DMapper(Mapper):
    r"""
    Glyph3DMapper - Glyph3D on the GPU.
    
    Superclass: Mapper
    
    Do the same job than Glyph3D but on the GPU. For this reason, it
    is a mapper not a PolyDataAlgorithm. Also, some methods of
    Glyph3D don't make sense in Glyph3DMapper: generate_point_ids,
    old-style set_source, point_ids_name, is_point_visible.
    
    @sa
    Glyph3D
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkGlyph3DMapper, obj, update, **traits)
    
    clamping = tvtk_base.false_bool_trait(desc=\
        r"""
        Turn on/off clamping of data values to scale with to the
        specified range.
        """
    )

    def _clamping_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetClamping,
                        self.clamping_)

    masking = tvtk_base.false_bool_trait(desc=\
        r"""
        Tells the mapper to skip glyphing input points that haves false
        values in the mask array. If there is no mask array (id access
        mode is set and there is no such id, or array name access mode is
        set and the there is no such name), masking is silently ignored.
        A mask array is a BitArray with only one component. Initial
        value is false.
        """
    )

    def _masking_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetMasking,
                        self.masking_)

    orient = tvtk_base.true_bool_trait(desc=\
        r"""
        Turn on/off orienting of input geometry. When turned on, the
        orientation array specified using set_orientation_array() will be
        used.
        """
    )

    def _orient_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetOrient,
                        self.orient_)

    scaling = tvtk_base.true_bool_trait(desc=\
        r"""
        Turn on/off scaling of source geometry. When turned on,
        scale_factor controls the scale applied. To scale with some data
        array, scale_mode should be set accordingly.
        """
    )

    def _scaling_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetScaling,
                        self.scaling_)

    source_indexing = tvtk_base.false_bool_trait(desc=\
        r"""
        Enable/disable indexing into table of the glyph sources. When
        disabled, only the 1st source input will be used to generate the
        glyph. Otherwise the source index array will be used to select
        the glyph source. The source index array can be specified using
        set_source_index_array().
        """
    )

    def _source_indexing_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetSourceIndexing,
                        self.source_indexing_)

    use_selection_ids = tvtk_base.false_bool_trait(desc=\
        r"""
        Turn on/off custom selection ids. If enabled, the id values set
        with set_selection_id_array are returned from pick events.
        """
    )

    def _use_selection_ids_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetUseSelectionIds,
                        self.use_selection_ids_)

    use_source_table_tree = tvtk_base.false_bool_trait(desc=\
        r"""
        If true, and the glyph source dataset is a subclass of
        DataObjectTree, the top-level members of the tree will be
        mapped to the glyph source table used for source_indexing.
        """
    )

    def _use_source_table_tree_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetUseSourceTableTree,
                        self.use_source_table_tree_)

    orientation_mode = tvtk_base.RevPrefixMap({'direction': 0, 'quaternion': 2, 'rotation': 1}, default_value='direction', desc=\
        r"""
        Orientation mode indicates if the orientation_array provides the
        direction vector for the orientation or the rotations around each
        axes. Default is DIRECTION
        """
    )

    def _orientation_mode_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetOrientationMode,
                        self.orientation_mode_)

    scale_mode = tvtk_base.RevPrefixMap({'no_data_scaling': 0, 'scale_by_magnitude': 1, 'scale_by_vector_components': 2}, default_value='no_data_scaling', desc=\
        r"""
        Either scale by individual components (SCALE_BY_COMPONENTS) or
        magnitude (SCALE_BY_MAGNITUDE) of the chosen array to SCALE with
        or disable scaling using data array all together
        (NO_DATA_SCALING). Default is NO_DATA_SCALING.
        """
    )

    def _scale_mode_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetScaleMode,
                        self.scale_mode_)

    def _get_block_attributes(self):
        return wrap_vtk(self._vtk_obj.GetBlockAttributes())
    def _set_block_attributes(self, arg):
        old_val = self._get_block_attributes()
        self._wrap_call(self._vtk_obj.SetBlockAttributes,
                        deref_vtk(arg))
        self.trait_property_changed('block_attributes', old_val, arg)
    block_attributes = traits.Property(_get_block_attributes, _set_block_attributes, desc=\
        r"""
        
        """
    )

    culling_and_lod = traits.Bool(False, enter_set=True, auto_set=False, desc=\
        r"""
        Enable or disable frustum culling and LOD of the instances. When
        enabled, an open_gl driver supporting GL_ARB_gpu_shader5 extension
        is mandatory.
        """
    )

    def _culling_and_lod_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetCullingAndLOD,
                        self.culling_and_lod)

    lod_coloring = traits.Bool(False, enter_set=True, auto_set=False, desc=\
        r"""
        Enable LOD coloring. It can be useful to configure properly the
        LODs. Each LOD have a unique color, based on its index.
        """
    )

    def _lod_coloring_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetLODColoring,
                        self.lod_coloring)

    range = traits.Array(enter_set=True, auto_set=False, shape=(2,), dtype="float", value=(0.0, 1.0), cols=2, desc=\
        r"""
        Specify range to map scalar values into.
        """
    )

    def _range_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetRange,
                        self.range)

    scale_factor = traits.Float(1.0, enter_set=True, auto_set=False, desc=\
        r"""
        Specify scale factor to scale object by. This is used only when
        Scaling is On.
        """
    )

    def _scale_factor_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetScaleFactor,
                        self.scale_factor)

    selection_color_id = traits.Int(1, enter_set=True, auto_set=False, desc=\
        r"""
        For selection by color id mode (not for end-user, called by
        GlyphSelectionRenderMode). 0 is reserved for miss. it has to
        start at 1. Initial value is 1.
        """
    )

    def _selection_color_id_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetSelectionColorId,
                        self.selection_color_id)

    def _get_source_table_tree(self):
        return wrap_vtk(self._vtk_obj.GetSourceTableTree())
    def _set_source_table_tree(self, arg):
        old_val = self._get_source_table_tree()
        self._wrap_call(self._vtk_obj.SetSourceTableTree,
                        deref_vtk(arg))
        self.trait_property_changed('source_table_tree', old_val, arg)
    source_table_tree = traits.Property(_get_source_table_tree, _set_source_table_tree, desc=\
        r"""
        Convenience method to get the source table tree, if it exists.
        """
    )

    def _get_input(self):
        return wrap_vtk(self._vtk_obj.GetInput())
    input = traits.Property(_get_input, desc=\
        r"""
        Get the input as a DataSet.  This method is overridden in the
        specialized mapper classes to return more specific data types.
        """
    )

    def _get_max_number_of_lod(self):
        return self._vtk_obj.GetMaxNumberOfLOD()
    max_number_of_lod = traits.Property(_get_max_number_of_lod, desc=\
        r"""
        Get the maximum number of LOD. open_gl context must be bound. The
        maximum number of LOD depends on GPU capabilities. This method is
        intended to be reimplemented in inherited classes, current
        implementation always returns zero.
        """
    )

    def get_source(self, *args):
        """
        get_source(self, idx:int=0) -> PolyData
        C++: PolyData *get_source(int idx=0)
        Get a pointer to a source object at a specified table location.
        """
        ret = self._wrap_call(self._vtk_obj.GetSource, *args)
        return wrap_vtk(ret)

    def set_input_data(self, *args):
        """
        set_input_data(self, __a:DataObject) -> None
        C++: void set_input_data(DataObject *)
        Assign a data object as input. Note that this method does not
        establish a pipeline connection. Use set_input_connection() to
        setup a pipeline connection.
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.SetInputData, *my_args)
        return ret

    def set_lod_distance_and_target_reduction(self, *args):
        """
        set_lod_distance_and_target_reduction(self, index:int, distance:float,
            targetReduction:float) -> None
        C++: virtual void set_lod_distance_and_target_reduction(
            IdType index, float distance, float targetReduction)
        Configure LODs. Culling must be enabled. distance have to be a
        positive value, it is the distance to the camera scaled by the
        instanced geometry bounding box. targetReduction have to be
        between 0 and 1, 0 disable decimation, 1 draw a point. This
        method is intended to be reimplemented in inherited classes,
        current implementation does nothing.
        
        @sa DecimatePro::SetTargetReduction
        """
        ret = self._wrap_call(self._vtk_obj.SetLODDistanceAndTargetReduction, *args)
        return ret

    def set_mask_array(self, *args):
        """
        set_mask_array(self, maskarrayname:str) -> None
        C++: void set_mask_array(const char *maskarrayname)
        set_mask_array(self, fieldAttributeType:int) -> None
        C++: void set_mask_array(int fieldAttributeType)
        Set the name of the point array to use as a mask for generating
        the glyphs. This is a convenience method. The same effect can be
        achieved by using set_input_array_to_process(vtkglyph3d_mapper::MASK,
        0, 0, DataObject::FIELD_ASSOCIATION_POINTS, maskarrayname)
        """
        ret = self._wrap_call(self._vtk_obj.SetMaskArray, *args)
        return ret

    def set_number_of_lod(self, *args):
        """
        set_number_of_lod(self, nb:int) -> None
        C++: virtual void set_number_of_lod(IdType nb)
        Set the number of LOD. This method is intended to be
        reimplemented in inherited classes, current implementation does
        nothing.
        """
        ret = self._wrap_call(self._vtk_obj.SetNumberOfLOD, *args)
        return ret

    def set_orientation_array(self, *args):
        """
        set_orientation_array(self, orientationarrayname:str) -> None
        C++: void set_orientation_array(const char *orientationarrayname)
        set_orientation_array(self, fieldAttributeType:int) -> None
        C++: void set_orientation_array(int fieldAttributeType)
        Tells the mapper to use an orientation array if Orient is true.
        An orientation array is a DataArray with 3 components. The
        first component is the angle of rotation along the X axis. The
        second component is the angle of rotation along the Y axis. The
        third component is the angle of rotation along the Z axis.
        Orientation is specified in X,Y,Z order but the rotations are
        performed in Z,X an Y. This definition is compliant with
        set_orientation method on Prop3D. By using vector or normal
        there is a degree of freedom or rotation left (underconstrained).
        With the orientation array, there is no degree of freedom left.
        This is convenience method. The same effect can be achieved by
        using set_input_array_to_process(vtkglyph3d_mapper::ORIENTATION, 0, 0,
        DataObject::FIELD_ASSOCIATION_POINTS, orientationarrayname);
        """
        ret = self._wrap_call(self._vtk_obj.SetOrientationArray, *args)
        return ret

    def set_scale_array(self, *args):
        """
        set_scale_array(self, scalarsarrayname:str) -> None
        C++: void set_scale_array(const char *scalarsarrayname)
        set_scale_array(self, fieldAttributeType:int) -> None
        C++: void set_scale_array(int fieldAttributeType)
        Convenience method to set the array to scale with. This is same
        as calling set_input_array_to_process(vtkglyph3d_mapper::SCALE, 0, 0,
        DataObject::FIELD_ASSOCIATION_POINTS, scalarsarrayname).
        """
        ret = self._wrap_call(self._vtk_obj.SetScaleArray, *args)
        return ret

    def set_selection_id_array(self, *args):
        """
        set_selection_id_array(self, selectionIdArrayName:str) -> None
        C++: void set_selection_id_array(const char *selectionIdArrayName)
        set_selection_id_array(self, fieldAttributeType:int) -> None
        C++: void set_selection_id_array(int fieldAttributeType)
        Convenience method to set the array used for selection IDs. This
        is same as calling
        set_input_array_to_process(vtkglyph3d_mapper::SELECTIONID, 0, 0,
        DataObject::FIELD_ASSOCIATION_POINTS, selectionidarrayname).
        
        * If no selection id array is specified, the index of the glyph
          point is
        * used.
        """
        ret = self._wrap_call(self._vtk_obj.SetSelectionIdArray, *args)
        return ret

    def set_source_connection(self, *args):
        """
        set_source_connection(self, idx:int, algOutput:AlgorithmOutput)
            -> None
        C++: void set_source_connection(int idx,
            AlgorithmOutput *algOutput)
        set_source_connection(self, algOutput:AlgorithmOutput) -> None
        C++: void set_source_connection(AlgorithmOutput *algOutput)
        Specify a source object at a specified table location. New style.
        Source connection is stored in port 1. This method is equivalent
        to set_input_connection(1, id, outputPort).
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.SetSourceConnection, *my_args)
        return ret

    def set_source_data(self, *args):
        """
        set_source_data(self, idx:int, pd:PolyData) -> None
        C++: void set_source_data(int idx, PolyData *pd)
        set_source_data(self, pd:PolyData) -> None
        C++: void set_source_data(PolyData *pd)
        Specify a source object at a specified table location.
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.SetSourceData, *my_args)
        return ret

    def set_source_index_array(self, *args):
        """
        set_source_index_array(self, arrayname:str) -> None
        C++: void set_source_index_array(const char *arrayname)
        set_source_index_array(self, fieldAttributeType:int) -> None
        C++: void set_source_index_array(int fieldAttributeType)
        Convenience method to set the array to use as index within the
        sources. This is same as calling
        set_input_array_to_process(vtkglyph3d_mapper::SOURCE_INDEX, 0, 0,
        DataObject::FIELD_ASSOCIATION_POINTS, arrayname).
        """
        ret = self._wrap_call(self._vtk_obj.SetSourceIndexArray, *args)
        return ret

    _updateable_traits_ = \
    (('clamping', 'GetClamping'), ('masking', 'GetMasking'), ('orient',
    'GetOrient'), ('scaling', 'GetScaling'), ('source_indexing',
    'GetSourceIndexing'), ('use_selection_ids', 'GetUseSelectionIds'),
    ('use_source_table_tree', 'GetUseSourceTableTree'),
    ('interpolate_scalars_before_mapping',
    'GetInterpolateScalarsBeforeMapping'), ('scalar_visibility',
    'GetScalarVisibility'), ('static', 'GetStatic'),
    ('use_lookup_table_scalar_range', 'GetUseLookupTableScalarRange'),
    ('abort_execute', 'GetAbortExecute'), ('release_data_flag',
    'GetReleaseDataFlag'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('orientation_mode', 'GetOrientationMode'), ('scale_mode',
    'GetScaleMode'), ('color_mode', 'GetColorMode'),
    ('resolve_coincident_topology', 'GetResolveCoincidentTopology'),
    ('scalar_mode', 'GetScalarMode'), ('culling_and_lod',
    'GetCullingAndLOD'), ('lod_coloring', 'GetLODColoring'), ('range',
    'GetRange'), ('scale_factor', 'GetScaleFactor'),
    ('selection_color_id', 'GetSelectionColorId'), ('array_access_mode',
    'GetArrayAccessMode'), ('array_component', 'GetArrayComponent'),
    ('array_id', 'GetArrayId'), ('array_name', 'GetArrayName'),
    ('field_data_tuple_id', 'GetFieldDataTupleId'), ('render_time',
    'GetRenderTime'), ('resolve_coincident_topology_polygon_offset_faces',
    'GetResolveCoincidentTopologyPolygonOffsetFaces'),
    ('resolve_coincident_topology_z_shift',
    'GetResolveCoincidentTopologyZShift'), ('scalar_range',
    'GetScalarRange'), ('progress', 'GetProgress'), ('progress_text',
    'GetProgressText'), ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'clamping', 'debug', 'global_warning_display',
    'interpolate_scalars_before_mapping', 'masking', 'orient',
    'release_data_flag', 'scalar_visibility', 'scaling',
    'source_indexing', 'static', 'use_lookup_table_scalar_range',
    'use_selection_ids', 'use_source_table_tree', 'color_mode',
    'orientation_mode', 'resolve_coincident_topology', 'scalar_mode',
    'scale_mode', 'array_access_mode', 'array_component', 'array_id',
    'array_name', 'culling_and_lod', 'field_data_tuple_id',
    'lod_coloring', 'progress_text', 'range', 'render_time',
    'resolve_coincident_topology_polygon_offset_faces',
    'resolve_coincident_topology_z_shift', 'scalar_range', 'scale_factor',
    'selection_color_id'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(Glyph3DMapper, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit Glyph3DMapper properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['clamping', 'interpolate_scalars_before_mapping', 'masking',
            'orient', 'scalar_visibility', 'scaling', 'source_indexing', 'static',
            'use_lookup_table_scalar_range', 'use_selection_ids',
            'use_source_table_tree'], ['color_mode', 'orientation_mode',
            'resolve_coincident_topology', 'scalar_mode', 'scale_mode'],
            ['array_access_mode', 'array_component', 'array_id', 'array_name',
            'culling_and_lod', 'field_data_tuple_id', 'lod_coloring', 'range',
            'render_time', 'resolve_coincident_topology_polygon_offset_faces',
            'resolve_coincident_topology_z_shift', 'scalar_range', 'scale_factor',
            'selection_color_id']),
            title='Edit Glyph3DMapper properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit Glyph3DMapper properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

