# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.non_linear_cell import NonLinearCell


class HigherOrderQuadrilateral(NonLinearCell):
    r"""
    HigherOrderQuadrilateral
    
    Superclass: NonLinearCell
    
    See Also:
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkHigherOrderQuadrilateral, obj, update, **traits)
    
    def get_order(self, *args):
        """
        get_order(self) -> Pointer
        C++: virtual const int *get_order()
        get_order(self, i:int) -> int
        C++: virtual int get_order(int i)"""
        ret = self._wrap_call(self._vtk_obj.GetOrder, *args)
        return ret

    def set_order(self, *args):
        """
        set_order(self, s:int, t:int) -> None
        C++: virtual void set_order(const int s, const int t)"""
        ret = self._wrap_call(self._vtk_obj.SetOrder, *args)
        return ret

    parametric_coords = traits.Array(enter_set=True, auto_set=False, shape=(12,), dtype="float", value=(0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 1.0, 0.0, 0.0, 1.0, 0.0), cols=3, desc=\
        r"""
        
        """
    )

    def _parametric_coords_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetParametricCoords,
                        self.parametric_coords)

    def _get_edge_cell(self):
        return wrap_vtk(self._vtk_obj.GetEdgeCell())
    edge_cell = traits.Property(_get_edge_cell, desc=\
        r"""
        
        """
    )

    def point_index_from_ijk(self, *args):
        """
        point_index_from_ijk(self, i:int, j:int, k:int) -> int
        C++: int point_index_from_ijk(int i, int j, int k)
        point_index_from_ijk(i:int, j:int, order:(int, ...)) -> int
        C++: static int point_index_from_ijk(int i, int j, const int *order)"""
        ret = self._wrap_call(self._vtk_obj.PointIndexFromIJK, *args)
        return ret

    def set_order_from_cell_data(self, *args):
        """
        set_order_from_cell_data(self, cell_data:CellData, numPts:int,
            cell_id:int) -> None
        C++: virtual void set_order_from_cell_data(CellData *cell_data,
            const IdType numPts, const IdType cell_id)"""
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.SetOrderFromCellData, *my_args)
        return ret

    def set_uniform_order_from_num_points(self, *args):
        """
        set_uniform_order_from_num_points(self, numPts:int) -> None
        C++: virtual void set_uniform_order_from_num_points(
            const IdType numPts)"""
        ret = self._wrap_call(self._vtk_obj.SetUniformOrderFromNumPoints, *args)
        return ret

    def sub_cell_coordinates_from_id(self, *args):
        """
        sub_cell_coordinates_from_id(self, ijk:Vector3i, subId:int) -> bool
        C++: bool sub_cell_coordinates_from_id(Vector3i &ijk, int subId)
        sub_cell_coordinates_from_id(self, i:int, j:int, k:int, subId:int)
            -> bool
        C++: bool sub_cell_coordinates_from_id(int &i, int &j, int &k,
            int subId)"""
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.SubCellCoordinatesFromId, *my_args)
        return ret

    def transform_approx_to_cell_params(self, *args):
        """
        transform_approx_to_cell_params(self, subCell:int, pcoords:[float,
            ...]) -> bool
        C++: bool transform_approx_to_cell_params(int subCell,
            double *pcoords)"""
        ret = self._wrap_call(self._vtk_obj.TransformApproxToCellParams, *args)
        return ret

    def get_edge_cell(self):
        """
        get_edge_cell(self) -> HigherOrderCurve
        C++: virtual HigherOrderCurve *get_edge_cell()"""
        ret = wrap_vtk(self._vtk_obj.getEdgeCell())
        return ret
        

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('parametric_coords',
    'GetParametricCoords'), ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'parametric_coords'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(HigherOrderQuadrilateral, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit HigherOrderQuadrilateral properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['parametric_coords']),
            title='Edit HigherOrderQuadrilateral properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit HigherOrderQuadrilateral properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

