# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.abstract_transform import AbstractTransform


class HomogeneousTransform(AbstractTransform):
    r"""
    HomogeneousTransform - superclass for homogeneous transformations
    
    Superclass: AbstractTransform
    
    HomogeneousTransform provides a generic interface for homogeneous
    transformations, i.e. transformations which can be represented by
    multiplying a 4x4 matrix with a homogeneous coordinate.
    @sa
    PerspectiveTransform LinearTransform IdentityTransform
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkHomogeneousTransform, obj, update, **traits)
    
    def _get_homogeneous_inverse(self):
        return wrap_vtk(self._vtk_obj.GetHomogeneousInverse())
    homogeneous_inverse = traits.Property(_get_homogeneous_inverse, desc=\
        r"""
        Just like get_inverse(), but includes typecast to
        HomogeneousTransform.
        """
    )

    def _get_matrix(self):
        return wrap_vtk(self._vtk_obj.GetMatrix())
    matrix = traits.Property(_get_matrix, desc=\
        r"""
        Get a copy of the internal transformation matrix.  The transform
        is Updated first, to guarantee that the matrix is valid.
        """
    )

    def get_matrix(self, *args):
        """
        get_matrix(self, m:Matrix4x4) -> None
        C++: void get_matrix(Matrix4x4 *m)
        get_matrix(self) -> Matrix4x4
        C++: Matrix4x4 *get_matrix()
        Get a copy of the internal transformation matrix.  The transform
        is Updated first, to guarantee that the matrix is valid.
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.GetMatrix, *my_args)
        return wrap_vtk(ret)

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(HomogeneousTransform, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit HomogeneousTransform properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], []),
            title='Edit HomogeneousTransform properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit HomogeneousTransform properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

