# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.threaded_image_algorithm import ThreadedImageAlgorithm


class ImageNonMaximumSuppression(ThreadedImageAlgorithm):
    r"""
    ImageNonMaximumSuppression - Performs non-maximum suppression
    
    Superclass: ThreadedImageAlgorithm
    
    ImageNonMaximumSuppression Sets to zero any pixel that is not a
    peak. If a pixel has a neighbor along the vector that has larger
    magnitude, the smaller pixel is set to zero.  The filter takes two
    inputs: a magnitude and a vector.  Output is magnitude information
    and is always in doubles. Typically this filter is used with
    ImageGradient and ImageGradientMagnitude as inputs.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkImageNonMaximumSuppression, obj, update, **traits)
    
    handle_boundaries = tvtk_base.true_bool_trait(desc=\
        r"""
        If "handle_boundaries_on" then boundary pixels are duplicated So
        central differences can get values.
        """
    )

    def _handle_boundaries_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetHandleBoundaries,
                        self.handle_boundaries_)

    dimensionality = traits.Trait(2, traits.Range(2, 3, enter_set=True, auto_set=False), desc=\
        r"""
        Determines how the input is interpreted (set of 2d slices or a 3D
        volume)
        """
    )

    def _dimensionality_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetDimensionality,
                        self.dimensionality)

    def _get_input(self):
        try:
            return wrap_vtk(self._vtk_obj.GetInput(0))
        except TypeError:
            return wrap_vtk(self._vtk_obj.GetInput())
    input = traits.Property(_get_input,
                            desc="The first input of this object, i.e. the result of `get_input(0)`.")
    
    def get_input(self, *args):
        """
        get_input(self, port:int) -> DataObject
        C++: DataObject *get_input(int port)
        get_input(self) -> DataObject
        C++: DataObject *get_input()
        Get a data object for one of the input port connections.  The use
        of this method is strongly discouraged, but some filters that
        were written a long time ago still use this method.
        """
        ret = self._wrap_call(self._vtk_obj.GetInput, *args)
        return wrap_vtk(ret)

    def set_magnitude_input_data(self, *args):
        """
        set_magnitude_input_data(self, input:ImageData) -> None
        C++: void set_magnitude_input_data(ImageData *input)
        Set the magnitude and vector inputs.
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.SetMagnitudeInputData, *my_args)
        return ret

    def set_vector_input_data(self, *args):
        """
        set_vector_input_data(self, input:ImageData) -> None
        C++: void set_vector_input_data(ImageData *input)"""
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.SetVectorInputData, *my_args)
        return ret

    _updateable_traits_ = \
    (('handle_boundaries', 'GetHandleBoundaries'), ('abort_execute',
    'GetAbortExecute'), ('release_data_flag', 'GetReleaseDataFlag'),
    ('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('split_mode', 'GetSplitMode'),
    ('dimensionality', 'GetDimensionality'), ('desired_bytes_per_piece',
    'GetDesiredBytesPerPiece'), ('enable_smp', 'GetEnableSMP'),
    ('global_default_enable_smp', 'GetGlobalDefaultEnableSMP'),
    ('minimum_piece_size', 'GetMinimumPieceSize'), ('number_of_threads',
    'GetNumberOfThreads'), ('progress', 'GetProgress'), ('progress_text',
    'GetProgressText'), ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'debug', 'global_warning_display',
    'handle_boundaries', 'release_data_flag', 'split_mode',
    'desired_bytes_per_piece', 'dimensionality', 'enable_smp',
    'global_default_enable_smp', 'minimum_piece_size',
    'number_of_threads', 'progress_text'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(ImageNonMaximumSuppression, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit ImageNonMaximumSuppression properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['handle_boundaries'], ['split_mode'],
            ['desired_bytes_per_piece', 'dimensionality', 'enable_smp',
            'global_default_enable_smp', 'minimum_piece_size',
            'number_of_threads']),
            title='Edit ImageNonMaximumSuppression properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit ImageNonMaximumSuppression properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

