# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.interactor_style import InteractorStyle


class InteractorStyleRubberBandZoom(InteractorStyle):
    r"""
    InteractorStyleRubberBandZoom - zoom in by amount indicated by
    rubber band box
    
    Superclass: InteractorStyle
    
    This interactor style allows the user to draw a rectangle in the
    render window using the left mouse button.  When the mouse button is
    released, the current camera zooms by an amount determined from the
    shorter side of the drawn rectangle.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkInteractorStyleRubberBandZoom, obj, update, **traits)
    
    center_at_start_position = tvtk_base.false_bool_trait(desc=\
        r"""
        When set to true (default, false), the position where the user
        starts the interaction is treated as the center of the box rather
        that one of the corners of the box.
        
        During interaction, modifier keys `Shift` or `Control` can be
        used to toggle this flag temporarily. In other words, if `Shift`
        or `Control` key is pressed, this class will act as if
        center_at_start_position was opposite of what it is set to.
        """
    )

    def _center_at_start_position_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetCenterAtStartPosition,
                        self.center_at_start_position_)

    lock_aspect_to_viewport = tvtk_base.false_bool_trait(desc=\
        r"""
        When set to true (default, false), the interactor will lock the
        rendered box to the viewport's aspect ratio.
        """
    )

    def _lock_aspect_to_viewport_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetLockAspectToViewport,
                        self.lock_aspect_to_viewport_)

    use_dolly_for_perspective_projection = tvtk_base.true_bool_trait(desc=\
        r"""
        If camera is in perspective projection mode, this interactor
        style uses Camera::Dolly to dolly the camera ahead for
        zooming. However, that can have unintended consequences such as
        the camera entering into the data. Another option is to use
        Camera::Zoom instead. In that case, the camera position is
        left unchanged, instead the focal point is changed to the center
        of the target box and then the view angle is changed to zoom in.
        To use this approach, set this parameter to false (default,
        true).
        """
    )

    def _use_dolly_for_perspective_projection_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetUseDollyForPerspectiveProjection,
                        self.use_dolly_for_perspective_projection_)

    _updateable_traits_ = \
    (('center_at_start_position', 'GetCenterAtStartPosition'),
    ('lock_aspect_to_viewport', 'GetLockAspectToViewport'),
    ('use_dolly_for_perspective_projection',
    'GetUseDollyForPerspectiveProjection'),
    ('auto_adjust_camera_clipping_range',
    'GetAutoAdjustCameraClippingRange'), ('handle_observers',
    'GetHandleObservers'), ('use_timers', 'GetUseTimers'), ('enabled',
    'GetEnabled'), ('key_press_activation', 'GetKeyPressActivation'),
    ('picking_managed', 'GetPickingManaged'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('mouse_wheel_motion_factor', 'GetMouseWheelMotionFactor'),
    ('pick_color', 'GetPickColor'), ('timer_duration',
    'GetTimerDuration'), ('key_press_activation_value',
    'GetKeyPressActivationValue'), ('priority', 'GetPriority'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['auto_adjust_camera_clipping_range', 'center_at_start_position',
    'debug', 'enabled', 'global_warning_display', 'handle_observers',
    'key_press_activation', 'lock_aspect_to_viewport', 'picking_managed',
    'use_dolly_for_perspective_projection', 'use_timers',
    'key_press_activation_value', 'mouse_wheel_motion_factor',
    'pick_color', 'priority', 'timer_duration'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(InteractorStyleRubberBandZoom, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit InteractorStyleRubberBandZoom properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['auto_adjust_camera_clipping_range',
            'center_at_start_position', 'enabled', 'handle_observers',
            'key_press_activation', 'lock_aspect_to_viewport', 'picking_managed',
            'use_dolly_for_perspective_projection', 'use_timers'], [],
            ['key_press_activation_value', 'mouse_wheel_motion_factor',
            'pick_color', 'priority', 'timer_duration']),
            title='Edit InteractorStyleRubberBandZoom properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit InteractorStyleRubberBandZoom properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

