# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.shader_property import ShaderProperty


class OpenGLShaderProperty(ShaderProperty):
    r"""
    OpenGLShaderProperty - represent GPU shader properties
    
    Superclass: ShaderProperty
    
    OpenGLShaderProperty is used to hold user-defined modifications of
    a GPU shader program used in a mapper.
    
    @sa
    ShaderProperty Uniforms OpenGLUniform
    
    @par Thanks: Developed by Simon Drouin (sdrouin2@bwh.harvard.edu) at
    Brigham and Women's Hospital.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkOpenGLShaderProperty, obj, update, **traits)
    
    def add_shader_replacement(self, *args):
        """
        add_shader_replacement(self, shaderType:Shader.Type,
            originalValue:str, replaceFirst:bool, replacementValue:str,
            replaceAll:bool) -> None
        C++: void add_shader_replacement(Shader::Type shaderType,
            const std::string &originalValue, bool replaceFirst,
            const std::string &replacementValue, bool replaceAll)
        This function enables you to apply your own substitutions to the
        shader creation process. The shader code in this class is created
        by applying a bunch of string replacements to a shader template.
        Using this function you can apply your own string replacements to
        add features you desire.
        """
        ret = self._wrap_call(self._vtk_obj.AddShaderReplacement, *args)
        return ret

    def clear_shader_replacement(self, *args):
        """
        clear_shader_replacement(self, shaderType:Shader.Type,
            originalValue:str, replaceFirst:bool) -> None
        C++: void clear_shader_replacement(Shader::Type shaderType,
            const std::string &originalValue, bool replaceFirst)"""
        ret = self._wrap_call(self._vtk_obj.ClearShaderReplacement, *args)
        return ret

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('fragment_shader_code',
    'GetFragmentShaderCode'), ('geometry_shader_code',
    'GetGeometryShaderCode'), ('vertex_shader_code',
    'GetVertexShaderCode'), ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'fragment_shader_code',
    'geometry_shader_code', 'vertex_shader_code'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(OpenGLShaderProperty, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit OpenGLShaderProperty properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['fragment_shader_code', 'geometry_shader_code',
            'vertex_shader_code']),
            title='Edit OpenGLShaderProperty properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit OpenGLShaderProperty properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

