# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.object import Object


class OutputWindow(Object):
    r"""
    OutputWindow - base class for writing debug output to a console
    
    Superclass: Object
    
    This class is used to encapsulate all text output, so that it will
    work with operating systems that have a stdout and stderr, and ones
    that do not.  (i.e windows does not).  Sub-classes can be provided
    which can redirect the output to a window.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkOutputWindow, obj, update, **traits)
    
    use_std_error_for_all_messages = tvtk_base.false_bool_trait(desc=\
        r"""
        Historically (VTK 8.1 and earlier), when printing messages to
        terminals, OutputWindow would always post messages to `cerr`.
        Setting this to true restores that incorrect behavior. When false
        (default), OutputWindow uses `cerr` for debug, error and
        warning messages, and `cout` for text messages.
        
        @deprecated use `set_display_mode_to_always_std_err` instead.
        """
    )

    def _use_std_error_for_all_messages_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetUseStdErrorForAllMessages,
                        self.use_std_error_for_all_messages_)

    display_mode = tvtk_base.RevPrefixMap({'default': -1, 'always': 1, 'always_std_err': 2, 'never': 0}, default_value='default', desc=\
        r"""
        
        """
    )

    def _display_mode_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetDisplayMode,
                        self.display_mode_)

    def _get_instance(self):
        return wrap_vtk(self._vtk_obj.GetInstance())
    def _set_instance(self, arg):
        old_val = self._get_instance()
        self._wrap_call(self._vtk_obj.SetInstance,
                        deref_vtk(arg))
        self.trait_property_changed('instance', old_val, arg)
    instance = traits.Property(_get_instance, _set_instance, desc=\
        r"""
        Return the singleton instance with no reference counting.
        """
    )

    def display_debug_text(self, *args):
        """
        display_debug_text(self, __a:str) -> None
        C++: virtual void display_debug_text(const char *)"""
        ret = self._wrap_call(self._vtk_obj.DisplayDebugText, *args)
        return ret

    def display_error_text(self, *args):
        """
        display_error_text(self, __a:str) -> None
        C++: virtual void display_error_text(const char *)"""
        ret = self._wrap_call(self._vtk_obj.DisplayErrorText, *args)
        return ret

    def display_generic_warning_text(self, *args):
        """
        display_generic_warning_text(self, __a:str) -> None
        C++: virtual void display_generic_warning_text(const char *)"""
        ret = self._wrap_call(self._vtk_obj.DisplayGenericWarningText, *args)
        return ret

    def display_text(self, *args):
        """
        display_text(self, __a:str) -> None
        C++: virtual void display_text(const char *)
        Display the text. Four virtual methods exist, depending on the
        type of message to display. This allows redirection or
        reformatting of the messages. The default implementation uses
        display_text for all. Consequently, subclasses can simply override
        display_text and use `get_current_message_type` to determine the type
        of message that's being reported.
        """
        ret = self._wrap_call(self._vtk_obj.DisplayText, *args)
        return ret

    def display_warning_text(self, *args):
        """
        display_warning_text(self, __a:str) -> None
        C++: virtual void display_warning_text(const char *)"""
        ret = self._wrap_call(self._vtk_obj.DisplayWarningText, *args)
        return ret

    def prompt_user_off(self):
        """
        prompt_user_off(self) -> None
        C++: virtual void prompt_user_off()"""
        ret = self._vtk_obj.PromptUserOff()
        return ret
        

    def prompt_user_on(self):
        """
        prompt_user_on(self) -> None
        C++: virtual void prompt_user_on()
        If prompt_user is set to true then each time a line of text is
        displayed, the user is asked if they want to keep getting
        messages.
        
        Note that prompt_user has not effect of messages displayed by
        directly calling `display_text`. The prompt is never shown for
        such messages.
        """
        ret = self._vtk_obj.PromptUserOn()
        return ret
        

    def set_prompt_user(self, *args):
        """
        set_prompt_user(self, _arg:bool) -> None
        C++: virtual void set_prompt_user(bool _arg)"""
        ret = self._wrap_call(self._vtk_obj.SetPromptUser, *args)
        return ret

    _updateable_traits_ = \
    (('use_std_error_for_all_messages', 'GetUseStdErrorForAllMessages'),
    ('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('display_mode', 'GetDisplayMode'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'use_std_error_for_all_messages',
    'display_mode'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(OutputWindow, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit OutputWindow properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['use_std_error_for_all_messages'], ['display_mode'], []),
            title='Edit OutputWindow properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit OutputWindow properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

