# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.surface_lic_interface import SurfaceLICInterface


class PSurfaceLICInterface(SurfaceLICInterface):
    r"""
    PSurfaceLICInterface - parallel parts of the SurfaceLICInterface
    
    Superclass: SurfaceLICInterface
    
    Parallel parts of the SurfaceLICInterface, see that class for
    documentation.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkPSurfaceLICInterface, obj, update, **traits)
    
    _updateable_traits_ = \
    (('anti_alias', 'GetAntiAlias'), ('enable', 'GetEnable'),
    ('enhanced_lic', 'GetEnhancedLIC'), ('mask_on_surface',
    'GetMaskOnSurface'), ('normalize_vectors', 'GetNormalizeVectors'),
    ('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('color_mode', 'GetColorMode'),
    ('composite_strategy', 'GetCompositeStrategy'), ('enhance_contrast',
    'GetEnhanceContrast'), ('generate_noise_texture',
    'GetGenerateNoiseTexture'), ('has_vectors', 'GetHasVectors'),
    ('high_color_contrast_enhancement_factor',
    'GetHighColorContrastEnhancementFactor'),
    ('high_lic_contrast_enhancement_factor',
    'GetHighLICContrastEnhancementFactor'),
    ('impulse_noise_background_value', 'GetImpulseNoiseBackgroundValue'),
    ('impulse_noise_probability', 'GetImpulseNoiseProbability'),
    ('lic_intensity', 'GetLICIntensity'),
    ('low_color_contrast_enhancement_factor',
    'GetLowColorContrastEnhancementFactor'),
    ('low_lic_contrast_enhancement_factor',
    'GetLowLICContrastEnhancementFactor'), ('map_mode_bias',
    'GetMapModeBias'), ('mask_color', 'GetMaskColor'), ('mask_intensity',
    'GetMaskIntensity'), ('mask_threshold', 'GetMaskThreshold'),
    ('max_noise_value', 'GetMaxNoiseValue'), ('min_noise_value',
    'GetMinNoiseValue'), ('noise_generator_seed',
    'GetNoiseGeneratorSeed'), ('noise_grain_size', 'GetNoiseGrainSize'),
    ('noise_texture_size', 'GetNoiseTextureSize'), ('noise_type',
    'GetNoiseType'), ('number_of_noise_levels', 'GetNumberOfNoiseLevels'),
    ('number_of_steps', 'GetNumberOfSteps'), ('step_size', 'GetStepSize'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['anti_alias', 'debug', 'enable', 'enhanced_lic',
    'global_warning_display', 'mask_on_surface', 'normalize_vectors',
    'color_mode', 'composite_strategy', 'enhance_contrast',
    'generate_noise_texture', 'has_vectors',
    'high_color_contrast_enhancement_factor',
    'high_lic_contrast_enhancement_factor',
    'impulse_noise_background_value', 'impulse_noise_probability',
    'lic_intensity', 'low_color_contrast_enhancement_factor',
    'low_lic_contrast_enhancement_factor', 'map_mode_bias', 'mask_color',
    'mask_intensity', 'mask_threshold', 'max_noise_value',
    'min_noise_value', 'noise_generator_seed', 'noise_grain_size',
    'noise_texture_size', 'noise_type', 'number_of_noise_levels',
    'number_of_steps', 'step_size'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(PSurfaceLICInterface, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit PSurfaceLICInterface properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['anti_alias', 'enable', 'enhanced_lic', 'mask_on_surface',
            'normalize_vectors'], [], ['color_mode', 'composite_strategy',
            'enhance_contrast', 'generate_noise_texture', 'has_vectors',
            'high_color_contrast_enhancement_factor',
            'high_lic_contrast_enhancement_factor',
            'impulse_noise_background_value', 'impulse_noise_probability',
            'lic_intensity', 'low_color_contrast_enhancement_factor',
            'low_lic_contrast_enhancement_factor', 'map_mode_bias', 'mask_color',
            'mask_intensity', 'mask_threshold', 'max_noise_value',
            'min_noise_value', 'noise_generator_seed', 'noise_grain_size',
            'noise_texture_size', 'noise_type', 'number_of_noise_levels',
            'number_of_steps', 'step_size']),
            title='Edit PSurfaceLICInterface properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit PSurfaceLICInterface properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

