# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.image_processing_pass import ImageProcessingPass


class SSAOPass(ImageProcessingPass):
    r"""
    SSAOPass - Implement a screen-space ambient occlusion pass.
    
    Superclass: ImageProcessingPass
    
    SSAO darkens some pixels to improve depth perception simulating
    ambient occlusion in screen space. For each fragment, random samples
    inside a hemisphere at the fragment position oriented with the normal
    are tested against other fragments to compute an average occlusion.
    The number of samples and the radius of the hemisphere are
    configurables.
    
    @sa
    RenderPass
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkSSAOPass, obj, update, **traits)
    
    blur = tvtk_base.false_bool_trait(desc=\
        r"""
        
        """
    )

    def _blur_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetBlur,
                        self.blur_)

    bias = traits.Float(0.01, enter_set=True, auto_set=False, desc=\
        r"""
        
        """
    )

    def _bias_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetBias,
                        self.bias)

    kernel_size = traits.Trait(32, traits.Range(1, 1000, enter_set=True, auto_set=False), desc=\
        r"""
        
        """
    )

    def _kernel_size_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetKernelSize,
                        self.kernel_size)

    radius = traits.Float(0.5, enter_set=True, auto_set=False, desc=\
        r"""
        
        """
    )

    def _radius_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetRadius,
                        self.radius)

    _updateable_traits_ = \
    (('blur', 'GetBlur'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'), ('bias',
    'GetBias'), ('kernel_size', 'GetKernelSize'), ('radius', 'GetRadius'),
    ('active_draw_buffers', 'GetActiveDrawBuffers'), ('reference_count',
    'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['blur', 'debug', 'global_warning_display', 'active_draw_buffers',
    'bias', 'kernel_size', 'radius'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(SSAOPass, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit SSAOPass properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['blur'], [], ['active_draw_buffers', 'bias', 'kernel_size',
            'radius']),
            title='Edit SSAOPass properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit SSAOPass properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

