# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.selector import Selector


class ValueSelector(Selector):
    r"""
    ValueSelector - selects elements matching chosen values.
    
    Superclass: Selector
    
    ValueSelector is a Selector that can select elements matching
    values. This can handle a wide array of
    SelectionNode::SelectionContent types. These include
    SelectionNode::GLOBALIDS, SelectionNode::PEDIGREEIDS,
    SelectionNode::VALUES, SelectionNode::INDICES, and
    SelectionNode::THRESHOLDS.
    
    A few things to note:
    
    * SelectionNode::SelectionList must be 2-component array for
      content-type = SelectionNode::THRESHOLDS and 1-component array
      for all other support content-types. For 1-component selection
      list, this will match items where the field array (or index) value
      matches any value in the selection list. For 2-component selection
      list, this will match those items with values in inclusive-range
      specified by the two components.
    
    * For SelectionNode::VALUES or SelectionNode::THRESHOLDS, the
      field array to select on is defined by the name given the
      selection_list itself. If the selection_list has no name (or is an
      empty string), then the active scalars from the dataset will be
      chosen.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkValueSelector, obj, update, **traits)
    
    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('insidedness_array_name',
    'GetInsidednessArrayName'), ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'insidedness_array_name'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(ValueSelector, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit ValueSelector properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['insidedness_array_name']),
            title='Edit ValueSelector properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit ValueSelector properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

