# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.view_node_factory import ViewNodeFactory


class VtkJSViewNodeFactory(ViewNodeFactory):
    r"""
    VtkJSViewNodeFactory - Constructs view nodes for traversing a
    scene for vtk-js
    
    Superclass: ViewNodeFactory
    
    VtkJSViewNodeFactory constructs view nodes that are subsequently
    executed as a scene graph is traversed. The generated view nodes
    inherit from ViewNode and augment the synchronize and render
    traversal steps to construct Json representations of the scene
    elements and to update the pipelines associated with the datasets to
    render, respectively.
    
    @sa
    VtkJSSceneGraphSerializer
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkVtkJSViewNodeFactory, obj, update, **traits)
    
    def _get_serializer(self):
        return wrap_vtk(self._vtk_obj.GetSerializer())
    def _set_serializer(self, arg):
        old_val = self._get_serializer()
        self._wrap_call(self._vtk_obj.SetSerializer,
                        deref_vtk(arg))
        self.trait_property_changed('serializer', old_val, arg)
    serializer = traits.Property(_get_serializer, _set_serializer, desc=\
        r"""
        
        """
    )

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(VtkJSViewNodeFactory, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit VtkJSViewNodeFactory properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], []),
            title='Edit VtkJSViewNodeFactory properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit VtkJSViewNodeFactory properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

