# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.object import Object


class XdmfDataArray(Object):
    r"""
    XdmfDataArray - no description provided.
    
    Superclass: Object
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkXdmfDataArray, obj, update, **traits)
    
    array = traits.Trait(None, None, traits.String(enter_set=True, auto_set=False), desc=\
        r"""
        
        """
    )

    def _array_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetArray,
                        self.array)

    def _get_vtk_array(self):
        return wrap_vtk(self._vtk_obj.GetVtkArray())
    def _set_vtk_array(self, arg):
        old_val = self._get_vtk_array()
        my_arg = deref_array([arg], [['vtkDataArray']])
        self._wrap_call(self._vtk_obj.SetVtkArray,
                        my_arg[0])
        self.trait_property_changed('vtk_array', old_val, arg)
    vtk_array = traits.Property(_get_vtk_array, _set_vtk_array, desc=\
        r"""
        
        """
    )

    def from_array(self):
        """
        from_array(self) -> DataArray
        C++: DataArray *from_array(void)"""
        ret = wrap_vtk(self._vtk_obj.FromArray())
        return ret
        

    def from_xdmf_array(self, *args):
        """
        from_xdmf_array(self, ArrayName:str=..., CopyShape:int=1,
            rank:int=1, Components:int=1, MakeCopy:int=1) -> DataArray
        C++: DataArray *from_xdmf_array(char *ArrayName=nullptr,
            int CopyShape=1, int rank=1, int Components=1, int MakeCopy=1)"""
        ret = self._wrap_call(self._vtk_obj.FromXdmfArray, *args)
        return wrap_vtk(ret)

    def to_array(self):
        """
        to_array(self) -> str
        C++: char *to_array(void)"""
        ret = self._vtk_obj.ToArray()
        return ret
        

    def to_xdmf_array(self, *args):
        """
        to_xdmf_array(self, DataArray:DataArray=..., CopyShape:int=1)
            -> str
        C++: char *to_xdmf_array(DataArray *DataArray=nullptr,
            int CopyShape=1)"""
        my_args = deref_array(args, [('vtkDataArray', 'int')])
        ret = self._wrap_call(self._vtk_obj.ToXdmfArray, *my_args)
        return ret

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('array', 'GetArray'), ('reference_count',
    'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'array'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(XdmfDataArray, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit XdmfDataArray properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['array']),
            title='Edit XdmfDataArray properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit XdmfDataArray properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

